
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>ThinkPHP框架入门知识 / iVAN</title>

    <meta name="description" content="ThinkPHP框架入门知识  ThinkPHP 是一个免费开源的,快速.简单的面向对象的 轻量级PHP开发框架 ,创立于2006年初,遵循Apache2开源协议发布,是为了敏捷WEB应用开发和简化企业应用开发而诞生的.ThinkPHP从诞生以来一直秉承简洁 实用的设计原则,在保持出色的性能和至简的代码的同时,也注重易用性.并且拥有众多的原创功能和特性,在社区团队的积极参与下,在易用性.扩展性和性能方 面不断优化和改进,已经成长为国内最领先和最具影响力的WEB应用开发框架,众多的典型案例确保可以稳定用于商业以及门户级的开发.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">ThinkPHP框架入门知识</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p> ThinkPHP 是一个免费开源的，快速、简单的面向对象的 轻量级PHP开发框架 ，创立于2006年初，遵循Apache2开源协议发布，是为了敏捷WEB应用开发和简化企业应用开发而诞生的。ThinkPHP从诞生以来一直秉承简洁 实用的设计原则，在保持出色的性能和至简的代码的同时，也注重易用性。并且拥有众多的原创功能和特性，在社区团队的积极参与下，在易用性、扩展性和性能方 面不断优化和改进，已经成长为国内最领先和最具影响力的WEB应用开发框架，众多的典型案例确保可以稳定用于商业以及门户级的开发。</p>
<p>ThinkPHP基于MVC的PHP框架<br />
M – Model 模型                工作：负责数据的操作<br />
V – View  视图（模板）        工作：负责前台页面显示<br />
C – Controller 控制器（模块） 工作：描述功能</p>
<p>ThinkPHP核心文件介绍<br />
├─ThinkPHP.php     框架入口文件<br />
├─Common 框架公共文件<br />
├─Conf 框架配置文件<br />
├─Extend 框架扩展目录<br />
├─Lang 核心语言包目录<br />
├─Lib 核心类库目录<br />
│  ├─Behavior 核心行为类库<br />
│  ├─Core 核心基类库<br />
│  ├─Driver 内置驱动<br />
│  │  ├─Cache 内置缓存驱动<br />
│  │  ├─Db 内置数据库驱动<br />
│  │  ├─TagLib 内置标签驱动<br />
│  │  └─Template 内置模板引擎驱动<br />
│  └─Template 内置模板引擎<br />
└─Tpl 系统模板目录</p>
<p>#项目目录结构及说明：<br />
Home 前台应用文件夹<br />
├─Common 项目公共文件目录<br />
├─Conf 项目配置目录<br />
├─Lang 项目语言目录<br />
├─Lib 项目类库目录<br />
│  ├─Action Action类库目录<br />
│  ├─Behavior 行为类库目录<br />
│  ├─Model 模型类库目录<br />
│  └─Widget Widget类库目录<br />
├─Runtime 项目运行时目录<br />
│  ├─Cache 模板缓存目录<br />
│  ├─Data 数据缓存目录<br />
│  ├─Logs 日志文件目录<br />
│  └─Temp 临时缓存目录<br />
└─Tpl 项目模板目录</p>
<p>ThinkPHP 3 MVC模式和URL访问<br />
什么是MVC<br />
M -Model 编写model类 对数据进行操作<br />
V -View  编写html文件，页面呈现<br />
C -Controller 编写类文件（UserAction.class.php）<br />
ThinkPHP的MVC特点<br />
编写非常灵活,只有view都可以执行</p>
<p>ThinkPHP的MVC对应的目录<br />
M 项目目录/应用目录/Lib/Model<br />
V 项目目录/应用目录/Tpl<br />
C 项目目录/应用目录/Lib/Action<br />
url访问C<br />
url的4种访问方式<br />
1.PATHINFO 模式</p>
<p>http://域名/项目名/入口文件/模块名/方法名/键1/值1/键2/值2</p>
<p>2.普通模式</p>
<p>http://域名/项目名/入口文件?m=模块名&amp;a=方法名&amp;键1=值1&amp;键2=值2</p>
<p>3.REWRITE模式</p>
<p>http://域名/项目名/模块名/方法名/键1/值1/键2/值2</p>
<p>4.兼容模式</p>
<p>http://域名/项目名/入口文件？s=模块名/方法名/键1/值1/键2/值2</p>
<p>ThinkPHP 3.1.2 输出和模型使用<br />
ThinkPHP 3 的输出<br />
a、通过 echo 等PHP原生的输出方式在页面中输出<br />
b、通过display方法输出<br />
想分配变量可以使用assign方法<br />
c、修改左右定界符<br />
休要修改配置文件中的配置项<br />
‘TMPL_L_DELIM’=&gt;'&lt;{‘, //修改左定界符<br />
‘TMPL_R_DELIM’=&gt;’}&gt;’, //修改右定界符</p>
<p>ThinkPHP 3 的模型使用<br />
需要在方法中通过new Model（表名）的形式操作数据库<br />
$m=new Model(‘User’);<br />
$arr=$m-&gt;select();<br />
‘DB_TYPE’=&gt;’mysql’,   //设置数据库类型<br />
‘DB_HOST’=&gt;’localhost’,//设置主机<br />
‘DB_NAME’=&gt;’thinkphp’,//设置数据库名<br />
‘DB_USER’=&gt;’root’,    //设置用户名<br />
‘DB_PWD’=&gt;”,        //设置密码<br />
‘DB_PORT’=&gt;’3306′,   //设置端口号<br />
‘DB_PREFIX’=&gt;’tp_’,  //设置表前缀<br />
也可以使用DSN方法进行配置<br />
‘DB_DSN’=&gt;’mysql://root:@localhost:3306/thinkphp’,//使用DSN方式配置数据库信息<br />
如果两种方式同时存在，以DSN方式为优先</p>
<p>还有一种简单实用模型的方式<br />
M() 等效为 new Model();<br />
$m=M(‘User’);<br />
$arr=$m-&gt;select();</p>
<p>使用模型的实例可以对数据进行操作，操作的工作一般就是对数据库进行 增删改查 CURD<br />
增 -C Create $m-&gt;add()<br />
删 -D Delete $m-&gt;delete()<br />
改 -U Update $m-&gt;save()<br />
查 -R Read   $m-&gt;select()</p>
<p>a、模板可以遍历数组</p>
<p>1<br />
2<br />
3<br />
    &lt;volist name='data' id='vo'&gt;<br />
            &lt;{$vo.id}&gt;----&lt;{$vo.username}&gt;-----&lt;{$vo.sex}&gt;&lt;br/&gt;<br />
    &lt;/volist&gt;<br />
b、我们可以开启调试功能中的page_trace<br />
1.开启调试功能<br />
//3.开启调试模式(在主入口文件配置index.php)<br />
define(‘APP_DEBUG’,true);<br />
2.我们需要设置配置文件，开启页面trace<br />
‘SHOW_PAGE_TRACE’=&gt;true,//开启页面Trace,需要有$this-&gt;display()才显示</p>
<p>CURD特性<br />
读取数据<br />
对数据的读取 Read<br />
$m=new Model(‘User’);<br />
$m=M(‘User’);<br />
select<br />
$m-&gt;select();//获取所有数据，以数组形式返回<br />
find<br />
$m-&gt;find(2);//获取单条数据<br />
getField(字段名)//获取一个具体的字段值<br />
$arr=$m-&gt;where(‘id=2′)-&gt;getField(‘username’);<br />
创建数据<br />
对数据的添加 Create<br />
$m=new Model(‘User’);<br />
$m=M(‘User’);<br />
$m-&gt;字段名=值<br />
$m-&gt;add();<br />
返回值是新增的id号<br />
删除数据<br />
$m=M(‘User’);<br />
$m-&gt;delete(2);               //删除id为2的数据<br />
$m-&gt;where(‘id=2′)-&gt;delete(); //与上面效果相同，也是删除id为2的数据<br />
返回值是受影响行数<br />
更新数据<br />
$m=M(‘User’);<br />
$data['id']=1;<br />
$data['username']=’ztz2′;<br />
$m-&gt;save($data);<br />
返回值是受影响行数</p>
<p>查询方式<br />
普通查询方式<br />
a、字符串<br />
$arr=$m-&gt;where(“sex=0 and username=’gege'”)-&gt;find();<br />
b、数组<br />
$data['sex']=0;<br />
$data['username']=’gege';<br />
$arr=$m-&gt;where($data)-&gt;find();<br />
注意：这种方式默认是and的关系，如果使用or关系，需要添加数组值<br />
$data['sex']=0;<br />
$data['username']=’gege';<br />
$data['_logic']=’or';<br />
表达式查询方式<br />
$data['id']=array(‘lt’,6);<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
EQ 等于<br />
NEQ不等于<br />
GT 大于<br />
EGT大于等于<br />
LT 小于<br />
ELT小于等于<br />
LIKE 模糊查询<br />
$data['username']=array(‘like’,’%ge’);<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
NOTLIKE<br />
$data['username']=array(‘notlike’,’%ge%’); //notlike中间没有空格<br />
$arr=$m-&gt;where($data)-&gt;select();</p>
<p>注意：如果一个字段要匹配多个通配符<br />
$data['username']=array(‘like’,array(‘%ge%’,’%2%’,’%五%’),’and’);//如果没有第三个值，默认关系是or关系<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
BETWEEN<br />
$data['id']=array(‘between’,array(5,7));<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
//SELECT * FROM tp_user WHERE ( (id BETWEEN 5 AND 7 ) )<br />
$data['id']=array(‘not between’,array(5,7));//注意，not 和 between中间一定要有空格<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
IN<br />
$data['id']=array(‘in’,array(4,6,7));<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
//SELECT * FROM tp_user WHERE ( id IN (4,6,7) )</p>
<p>$data['id']=array(‘not in’,array(4,6,7));<br />
$arr=$m-&gt;where($data)-&gt;select();<br />
//SELECT * FROM tp_user WHERE ( id NOT IN (4,6,7) )<br />
区间查询<br />
$data['id']=array(array(‘gt’,4),array(‘lt’,10));//默认关系是 and 的关系<br />
//SELECT * FROM tp_user WHERE ( (id &gt; 4) AND (id &lt; 10) )</p>
<p>$data['id']=array(array(‘gt’,4),array(‘lt’,10),’or’) //关系就是or的关系</p>
<p>$data['name']=array(array(‘like’,’%2%’),array(‘like’,’%五%’),’gege’,’or’);<br />
统计查询<br />
count //获取个数<br />
max   //获取最大数<br />
min   //获取最小数<br />
avg   //获取平均数<br />
sum   //获取总和<br />
SQL直接查询<br />
a、query 主要数处理读取数据的<br />
成功返回数据的结果集<br />
失败返回boolean false<br />
$m=M();<br />
$result=$m-&gt;query(“select *  from t_user where id &gt;50″);<br />
var_dump($result);<br />
b、execute 用于更新个写入操作<br />
成功返回影响行数<br />
失败返回boolean false<br />
$m=M();<br />
$result=$m-&gt;execute(“insert into t_user(username) values(‘ztz3′)”);<br />
var_dump($result);</p>
<p>连贯操作<br />
常用连贯操作<br />
1.where<br />
帮助我们设置查询条件<br />
2.order<br />
对结果进行排序<br />
$arr=$m-&gt;order(‘id desc’)-&gt;select();<br />
$arr=$m-&gt;order(array(‘id’=&gt;’desc’,’sex’=&gt;’asc’))-&gt;select();<br />
3.limit<br />
限制结果<br />
limit(2,5)<br />
limit(‘2,5′)<br />
limit(10)//limit(0,10)<br />
4.field<br />
设置查询字段<br />
field(‘username as name,id’)<br />
field(array(‘username’=&gt;’name’,’id’)<br />
field(‘id’,true) //获取除了id以外的所有字段<br />
5.table<br />
设置表名<br />
6.group<br />
分组<br />
7.having</p>
<p>alias 用于给当前数据表定义别名 字符串<br />
page 用于查询分页（内部会转换成limit） 字符串和数字<br />
join* 用于对查询的join支持 字符串和数组<br />
union* 用于对查询的union支持 字符串、数组和对象<br />
distinct 用于查询的distinct支持 布尔值<br />
lock 用于数据库的锁机制 布尔值<br />
cache 用于查询缓存 支持多个参数（以后在缓存部分再详细描述）<br />
relation 用于关联查询（需要关联模型扩展支持） 字符串<br />
validate 用于数据自动验证 数组<br />
auto 用于数据自动完成 数组<br />
filter 用于数据过滤 字符串<br />
scope* 用于命名范围 字符串、数组</p>
<p> 视图<br />
模板的使用<br />
a、规则<br />
模板文件夹下[TPL]/[分组文件夹/][模板主题文件夹/]和模块名同名的文件夹[Index]/和方法名同名的文件[index].html（.tpl）<br />
更换模板文件的后缀名（修改配置文件）<br />
‘TMPL_TEMPLATE_SUFFIX’=&gt;’.html’,//更改模板文件后缀名<br />
b、修改模板文件目录层次<br />
‘TMPL_FILE_DEPR’=&gt;’_’,//修改模板文件目录层次<br />
c、模板主题<br />
‘DEFAULT_THEME’=&gt;’your’,//设置默认模板主题<br />
需要在TPL下面新建一个your文件夹作为模板主题文件夹<br />
如何动态修改模板主题？<br />
1、在后台准备一个功能，修改config.php文件中的默认模板项<br />
2、通过url传递 t=主题 参数可以修改不同的模板<br />
‘DEFAULT_THEME’=&gt;’your’,//设置默认模板主题<br />
‘TMPL_DETECT_THEME’=&gt;true,//自动侦测模板主题<br />
‘THEME_LIST’=&gt;’your,my’,//支持的模板主题列表</p>
<p>输出模板内容<br />
a、display<br />
1.display中没有参数<br />
$this-&gt;display();<br />
2.可以带参数<br />
$this-&gt;display(本模块文件夹下的其他模板文件);<br />
$this-&gt;display(‘index2′);</p>
<p>$this-&gt;display(其他文件夹下的模板文件);<br />
$this-&gt;display(‘Public:error’);//注意，仅仅需要在Tpl下有Public文件夹以及其中的error.html即可，不需要一定有Public模块</p>
<p>$this-&gt;display(其他主题下的 文件夹下的 模板文件);//需要开启主题支持<br />
$this-&gt;display(‘my:Index:index’);</p>
<p>$this-&gt;display(一个url路径);<br />
$this-&gt;display(‘./Public/error.html’);</p>
<p>$this-&gt;display(‘./Public/error.html’,’utf-8′,’text/xml’);</p>
<p>$this-&gt;show($content);<br />
3.fetch方法<br />
获得模板文件中的内容，以字符串形式返回<br />
$content=$this-&gt;fetch(‘Public:error’);<br />
4.show方法<br />
不需要模板文件，可以直接输出模板内容<br />
$content=$this-&gt;fetch(‘Public:error’);<br />
dump($content);<br />
$content=str_replace(‘h1′,’i’,$content);<br />
$this-&gt;show($content);<br />
模板中的赋值<br />
//$this-&gt;assign(‘name’,’赵桐正’);<br />
$this-&gt;name=’赵桐正2′;<br />
$this-&gt;display();<br />
模板替换<br />
__PUBLIC__：会被替换成当前网站的公共目录 通常是 /Public/<br />
__ROOT__： 会替换成当前网站的地址（不含域名）<br />
__APP__： 会替换成当前项目的URL地址 （不含域名）<br />
__GROUP__：会替换成当前分组的URL地址 （不含域名）<br />
__URL__： 会替换成当前模块的URL地址（不含域名）<br />
__ACTION__：会替换成当前操作的URL地址 （不含域名）<br />
__SELF__： 会替换成当前的页面URL</p>
<p>更换模板变量规则，修改配置项<br />
‘TMPL_PARSE_STRING’=&gt;array(           //添加自己的模板变量规则<br />
‘__CSS__’=&gt;__ROOT__.’/Public/Css’,<br />
‘__JS__’=&gt;__ROOT__.’/Public/Js’,<br />
),</p>
<p>模板中的变量<br />
变量输出<br />
1.标量输出<br />
2.数组输出<br />
{$name[1]}      //索引数组<br />
{$name['k2']}   //关联数组<br />
{$name.k1}<br />
3.对象输出<br />
{$name:k}<br />
{$name-&gt;k}<br />
系统变量<br />
{$Think.get.id}<br />
使用函数<br />
{$name|strtoupper} 生成的编译后文件是 &lt;?php echo (strtoupper($name)); ?&gt;<br />
{$name|date=’Y m d H:i:s’,###}<br />
默认值<br />
{$name|default=’这里是默认值’}<br />
运算符<br />
+ – * / % ++ —<br />
{$name++}</p>
<p>模板中的基本语法<br />
导入CSS和JS文件<br />
1、css link<br />
js  scr<br />
&lt;link rel=’stylesheet’ type=’text/css’ href=’__PUBLIC__/Css/test.css’/&gt;<br />
&lt;script src=’__PUBLIC__/Js/test.js’&gt;&lt;/script&gt;<br />
2.import<br />
&lt;import type=’js’ file=’Js.test’ /&gt; //导入Public文件夹下面的Js目录中的test.js文件，import标签可以省略type属性，默认就是js的<br />
&lt;import type=’css’ file=’Css.test’ /&gt;<br />
//可以更改默认文件夹 设置basepath属性<br />
&lt;import type=’js’ file=’Js.my’ basepath=’./Other’/&gt;<br />
3.load<br />
//方法可以自动检测导入的文件类型<br />
&lt;load href=’__PUBLIC__/Js/test.js’ /&gt;<br />
分支结构<br />
1、if<br />
&lt;if condition=’$sex eq “男”‘&gt;<br />
男人是泥巴做的<br />
&lt;else /&gt;<br />
女人是水做的<br />
&lt;/if&gt;</p>
<p>&lt;if condition=’$age lt 18′&gt;<br />
未成年<br />
&lt;elseif  condition=’$age eq 18’/&gt;<br />
青春年少<br />
&lt;else /&gt;<br />
成年<br />
&lt;/if&gt;<br />
&gt;  gt<br />
&lt;  lt<br />
== eq<br />
&lt;= elt<br />
&gt;= egt<br />
!= neq<br />
=== heq<br />
!== nheq</p>
<p>&lt;switch name=’number’&gt;<br />
&lt;case value=’1′&gt;一个和尚挑水吃&lt;/case&gt;<br />
&lt;case value=’2′&gt;两个和尚台水吃&lt;/case&gt;<br />
&lt;case value=’3′&gt;三个和尚没水吃&lt;/case&gt;<br />
&lt;default/&gt; 这里是默认值<br />
&lt;/switch&gt;<br />
循环结构<br />
1.for<br />
&lt;table border=’1′ width=’500′&gt;<br />
&lt;for start=’10’ end=’00’ name=’j’ step=’-2′ comparison=’gt’&gt;<br />
&lt;tr&gt;&lt;td&gt;{$j}&lt;/td&gt;&lt;td&gt;abc&lt;/td&gt;&lt;/tr&gt;<br />
&lt;/for&gt;<br />
&lt;/table&gt;</p>
<p>2.volist<br />
&lt;volist name=’list’ id=’v’&gt;<br />
{$v.username}&lt;br/&gt;<br />
&lt;/volist&gt;<br />
3.foreach<br />
&lt;foreach name=’list’ item=’v’ key=’k’&gt;<br />
{$k}——-{$v}&lt;br/&gt;<br />
&lt;/foreach&gt;<br />
特殊标签<br />
1、比较标签<br />
eq或者 equal 等于<br />
neq 或者notequal 不等于<br />
gt 大于<br />
egt 大于等于<br />
lt 小于<br />
elt 小于等于<br />
heq 恒等于<br />
nheq 不恒等于</p>
<p>2.范围标签<br />
in<br />
&lt;in name=’n’ value=’9,10,11,12′&gt;在这些数字里面&lt;else/&gt;不在这些数字的范围内&lt;/in&gt;<br />
&lt;notin name=’n’ value=’9,10,11,12′&gt;在这些数字里面&lt;else/&gt;不在这些数字的范围内&lt;/in&gt;<br />
between<br />
&lt;notbetween name=’n’ value=’1,10′&gt;{$n}在1-10之间&lt;else/&gt;{$n}不在1到10之间&lt;/between&gt;<br />
3.present<br />
标签来判断模板变量是否已经赋值，<br />
&lt;present name=’m’&gt;m有赋值&lt;else/&gt;m没有赋值&lt;/present&gt;<br />
4.Empty<br />
empty标签判断模板变量是否为空，<br />
&lt;empty name=’n’&gt;n为空赋值&lt;else/&gt;n有值&lt;/empty&gt;<br />
5.Defined<br />
判断常量是否已经定义<br />
6.Define<br />
在模板中定义常量<br />
7.Assing<br />
模板中变量赋值</p>
<p>其他标签使用<br />
1、在模板中直接使用PHP代码<br />
&lt;php&gt; echo “我是赵桐正” &lt;/php&gt;<br />
2、建议更改左右定界符<br />
在配置文件中改变<br />
‘TMPL_L_DELIM’=&gt;'&lt;{‘, //修改左定界符<br />
‘TMPL_R_DELIM’=&gt;’}&gt;’, //修改右定界符</p>
<p>模板的使用技巧<br />
模板包含<br />
&lt;include file=”完整模板文件名” /&gt;<br />
&lt;include file=”./Tpl/default/Public/header.html” /&gt;<br />
&lt;include file=”read” /&gt;<br />
&lt;include file=”Public:header” /&gt;<br />
&lt;include file=”blue:User:read” /&gt;<br />
&lt;include file=”$tplName” /&gt;<br />
&lt;include file=”header” title=”ThinkPHP框架”keywords=”开源WEB开发框架”/&gt;<br />
在模板中变量用[变量]接受<br />
&lt;include file=’file1,file2′ /&gt;<br />
模板渲染<br />
1、自动开启模板渲染 设置配置文件<br />
‘LAYOUT_ON’=&gt;true,//开启模板渲染<br />
准备一个模板渲染页面，在页面中使用{__CONTENT__}接受具体模板页面的内容<br />
如果在摸一个具体模板中不希望使用渲染模板，可以在页首添加{__NOCONTENT__}<br />
2、不开启自动模板渲染可以在每一个具体页面的页首添加<br />
&lt;layout name=’layout’/&gt;<br />
3.使用技巧<br />
在渲染模板文件中也可以使用其他模板文件的内容<br />
&lt;include file=’Public:header’/&gt;<br />
&lt;body&gt;<br />
&lt;p&gt;这里是渲染页面！！！&lt;/p&gt;<br />
{__CONTENT__}<br />
&lt;/body&gt;<br />
&lt;/html&gt;<br />
模板的继承   </p>
<p> 控制器的模块和操作<br />
空模块和空操作<br />
1、空操作<br />
function _empty($name){<br />
$this-&gt;show(“$name 不存在 &lt;a href=’__APP__/Index/index’&gt;返回首页&lt;/a&gt;”);<br />
}<br />
2.空模块<br />
class EmptyAction extends Action{<br />
function index(){<br />
$city=M(‘City’);<br />
$arr=$city-&gt;select();<br />
$this-&gt;assign(‘list’,$arr);<br />
$name=MODULE_NAME;<br />
$this-&gt;display(“City:$name”);<br />
}<br />
}</p>
<p>前置操作和后置操作<br />
1、前置操作： _before_操作名<br />
2、后置操作： _after_操作名</p>
<p> URL<br />
URL规则<br />
1、默认是区分大小写的<br />
2、如果我们不想区分大小写可以改配置文件<br />
‘URL_CASE_INSENSITIVE’=&gt;true,//url不区分大小写<br />
3、如果模块名为 UserGroupAction<br />
那么url找模块就必要要写成</p>
<p>http://localhost/thinkphp4/index.php/user_group/index</p>
<p>4、如果’URL_CASE_INSENSITIVE’=&gt;false<br />
那么url也可以写为</p>
<p>http://localhost/thinkphp4/index.php/UserGroup/index</p>
<p>URL伪静态<br />
‘URL_HTML_SUFFIX’=&gt;’html|shtml|xml’,//限制伪静态的后缀<br />
URL路由<br />
1、启动路由<br />
要在配置文件中开启路由支持<br />
2、使用路由<br />
1.规则表达式配置路由<br />
‘my’=&gt;’Index/index’,//静态地址路由<br />
‘:id/:num’=&gt;’Index/index’,//动态地址路由<br />
‘year/:year/:month/:date’=&gt;’Index/index’,//动态和静态混合地址路由<br />
‘year/:yeard/:monthd/:dated’=&gt;’Index/index’,//动态和静态混合地址路由<br />
加上 d代表类型只能是数字<br />
‘my/:id$’=&gt;’Index/index’,// 加上$说明地址中只能是 my/1000 后面不能有其他内容了<br />
2.正则表达式配置路由<br />
‘/^year/(d{4})/(d{2})/(d{2})/’=&gt;’Index/index?year=:1&amp;month=:2&amp;date=:3′<br />
3、注意事项：<br />
1.越复杂的路由越往前面放<br />
‘URL_ROUTE_RULES’=&gt;array(<br />
‘my/:year/:month:/:day’=&gt;’Index/day’,<br />
‘my/:idd’=&gt;’Index/index’,<br />
‘my/:name’=&gt;’Index/index’,<br />
)<br />
2.可以使用$作为完全匹配的路由规则<br />
‘URL_ROUTE_RULES’=&gt;array(<br />
‘my/:idd$’=&gt;’Index/index’,<br />
‘my/:name$’=&gt;’Index/index’,<br />
‘my/:year/:month:/:day$’=&gt;’Index/day’,<br />
),<br />
3.用正则匹配的方式<br />
‘URL_ROUTE_RULES’=&gt;array(<br />
‘/^my/(d+)$/’=&gt;’Index/index?id=:1′,<br />
‘/^my/(w+)$/’=&gt;’Index/index?name=:1′,<br />
‘/^my/(d{4})/(d{2})/(d{2})$/’=&gt;’Index/day?year=:1&amp;month=:2&amp;day=:3′,<br />
),</p>
<p>URL重写<br />
URL生成</p>
<p> 分组、页面跳转与ajax<br />
多应用配置技巧<br />
使用分组<br />
页面跳转<br />
$this-&gt;success(‘查询成功’,U(‘User/test’));<br />
$this-&gt;redirect(‘User/test’,”,5,’页面正在跳’);<br />
Ajax技巧<br />
大C方法  获取配置文件中数组名称和值<br />
echo C(‘DB_USER’);</p>
<p>大F方法  文件处理<br />
写:F(‘文件名’,’数组’,’目录’);<br />
读:F(‘文件名’,”,’目录’);</p>
<p>大U方法  URL处理<br />
在PHP里<br />
U(‘方法名’)<br />
在模板中<br />
当前函数{:U(‘方法名’)}<br />
其他函数{:U(‘函数/方法名’)}</p>
<p>*文件引入<br />
&lt;css file=’__PUBLIC__/css/base.css’ /&gt;<br />
&lt;js file=’__PUBLIC__/js/base.js’ /&gt;</p>
<p>*表单处理<br />
方法1 $this-&gt;_post(”);<br />
获取提交表单,会使用函数htmlspecialchars()过滤<br />
$username=$this-&gt;_post(‘username’);</p>
<p>方法2  I(‘username’);  [3.1.3新功能]<br />
大I,自动判断post和get<br />
$username=I(‘username’);<br />
echo I(‘username’,’不存在值时的默认值’,’使用函数’);</p>
<p>查看是否有数据提交:<br />
print_r(I(‘post.’));</p>
<p>禁止表单处理函数的访问,提升安全性<br />
方法1<br />
if(!$this-&gt;isPost()) _404(‘页面不存在’,U(‘index’));<br />
echo ‘正常提交';</p>
<p>方法2 (推荐)  halt 页面可以定制错误页面:<br />
if(!IS_POST) halt(‘页面不存在’);<br />
echo ‘正常提交';</p>
<p>制定方法:在Conf/config.php 添加:’TMPL_EXCEPTION_FILE’=&gt;’./Public/Tpl/error.html’,<br />
文件接受错误内容:./Public/Tpl/error.html,只能写原生php,支持常量,如__APP__<br />
&lt;?php echo $e['message']; ?&gt;</p>
<p>//返回插入的ID值,数据库从1开始<br />
if(M(‘user’)-&gt;data($data)-&gt;add()){<br />
$this-&gt;success(‘添加成功’,’index’);<br />
}else{<br />
$this-&gt;error(‘添加失败’);<br />
}</p>
<p>*输出到模板</p>
<p>1,数据准备<br />
方法1<br />
$this-&gt;assign(‘变量名’,’变量值’)</p>
<p>方法2<br />
$this-&gt;变量名=’变量值';</p>
<p>方法3(新版本,缩短了代码)<br />
$this-&gt;assign(‘变量名’,’变量值’)-&gt;display();</p>
<p>方法4(一行搞定)<br />
$this-&gt;assign(‘data’,M(‘User’)-&gt;select())-&gt;display();</p>
<p>2,模板输出<br />
方法1(.语法会判断是对象还是数组,配置参数:TMP_VAR_IDENTIFY=&gt;’array’, 这样就会认为是数组,以提高速度)<br />
&lt;foreach name=’data’ item=’v’&gt;<br />
{$v.username}—{$v.password}—{$v.time|date=’y-m-d H:i:s,###’}<br />
&lt;/foreach&gt;</p>
<p>使用函数 {:phpinfo()}</p>
<p>方法2<br />
volist</p>
<p>*分组应用(应用组)前后台只用一个入口文件<br />
idnex.php (默认)<br />
&lt;?php<br />
define(‘APP_NAME’,’App’);<br />
define(‘APP_PATH’,’./App/’);<br />
define(‘APP_DEBUG’,’TRUE’);<br />
require ‘./ThinkPHP/ThinkPHP.php';<br />
?&gt;</p>
<p>App/Conf/config.php<br />
&lt;?php<br />
return array(<br />
//开启分组<br />
‘APP_GROUP_LIST’=&gt;’Index,Admin’,<br />
‘DEFAULT_GROUP’=&gt;’Index’,</p>
<p>‘TMPL_FILE_DEPR’=&gt;’_’, //默认模板分隔符为_而非文件夹形式<br />
);</p>
<p>自定义控制器<br />
1,在Action文件夹删除原来的默认控制器<br />
2,建立两个文件夹,分别为前台和后台如Index Admin<br />
访问: 前台host/index.php/Index   后台host/index.php/Admin</p>
<p>自定义配置文件(互相不能访问,但公共配置可以互相访问)<br />
1,在host/App/Conf/建立两个文件夹,分别为前台和后台如Index Admin<br />
配置: 前台host/App/Conf/Index/config.php<br />
后台host/App/Conf/Admin/config.php</p>
<p>自定义函数<br />
1,在host/App/Common/建立两个文件夹,分别为前台和后台如Index Admin<br />
配置: 前台host/App/Common/Index/function.php<br />
后台host/App/Common/Admin/function.php</p>
<p>注意:分组应用不支持{:U(“form_save”)}直接使用,即当前控制器当前方法,这样写:<br />
{:U(“/Index/Index/form_save”)}<br />
*分组应用[完毕]</p>
<p>**独立分组配置<br />
开启：<br />
1，先配置应用分组<br />
2，添加参数<br />
‘APP_GROUP_MODE’=&gt;1,  //开启独立分组<br />
‘APP_GROUP_PATH’=&gt;’Modules’, //默认分组路径，默认：Modules</p>
<p>常用路径变量：__ROOT__.’/’.APP_NAME.’/’.C(‘APP_GROUP_PATH’).’/’.GROUP_NAME.’/’<br />
新的目录结构：<br />
ThinkPHP  //系统目录<br />
App       //项目目录<br />
Public    //静态文件目录<br />
index.php //所有项目的入口文件</p>
<p>App：<br />
Modules   //项目模块  ==&gt;Admin/Action,Tpl,Model,Conf,Common; Index/Action,Tpl,Model,Conf,Common;<br />
Common    //公共Common<br />
Conf      //公共Conf<br />
Lib       //公共Lib<br />
Tpl       //公共Tpl<br />
Runtimes  //运行时</p>
<p>Public：<br />
css js img</p>
<p>**JQuery 异步提交<br />
$(‘#send-btn’).click(<br />
function(){<br />
var username=$(‘input[username=username]‘);<br />
var password=$(‘input[password=password]‘);</p>
<p>if(username.val()==”){<br />
alert(‘用户名不能为空’);<br />
username.focus();<br />
//让用户名获取焦点<br />
return;<br />
}</p>
<p>if(password.val()==”){<br />
alert(‘密码不能为空’);<br />
password.focus();<br />
//让用户名获取焦点<br />
return;<br />
}</p>
<p>//开始异步传输(要在模板内才可以解析php,不可以在单独js文件操作)<br />
var sendUrl='{:U(“Index/Index/form_save”,”,”)}';</p>
<p>$.post(sendUrl,{username:username.val(),password:password.val()},function(data){},’json’);<br />
}<br />
);</p>
<p>**php异步表单处理:<br />
Public function form_save(){<br />
//var_dump($this-&gt;isAjax());   //判断是否有数据提交<br />
//var_dump(IS_AJAX);           //[新版本]判断是否有数据提交<br />
if(!$this-&gt;isAjax()) halt (‘页面不存在’);<br />
$data=array(<br />
‘username’=&gt;$this-&gt;_post(‘username’),<br />
‘password’=&gt;$this-&gt;_post(‘password’),<br />
‘time’=&gt;time()<br />
);<br />
//p($data);</p>
<p>}</p>
<p>11课开始没记录</p>
<p>*引入模块<br />
1,验证码模块,核心包里没有,需要手动添加,放在ThinkPHP/Extend/Library/ORG/Util/Image.class.php<br />
import(‘ORG.Util.Image’);<br />
Image::BuildImageVerify(4,5,’png’);<br />
访问:该方法地址即可<br />
换验证码,使用一个JS随机数函数:Math.random();<br />
注意:如果出现伪静态后缀名,需要在{:U(‘Admin/Login/index’),”,”} 增加2个空参数<br />
混合模式区分大小写</p>
<p>验证码后台验证<br />
if(md5($_POST[code])!= session('verify')){ $this-&gt;error('验证码错误');}<br />
if(md5($this-&gt;_post[code])!= session('verify')){ $this-&gt;error('验证码错误');}<br />
if(I('code','','md5')!= session('verify')){ $this-&gt;error('验证码错误');}</p>
<p>2,分页类<br />
import('ORG.Util.Page');  //导入类<br />
$max=M('User')-&gt;count();  //查询总条数<br />
$page=new Page($max,5,'','Index/Index/index/p/');<br />
//实例化对象,参数:1总条数,2每页条数,3分页跳转的参数,4设置URL路径,在分组时有用,因为少个应用组名<br />
$limit=$page-&gt;firstRow.','.$page-&gt;listRows;  //获取第一页和总页数并设置为limit值<br />
$m=M('User')-&gt;order('time DESC')-&gt;limit($limit)-&gt;select(); //查出第一页的数据<br />
$this-&gt;User=$m;   //把数据分配给前台模板,用于foreach遍历<br />
$this-&gt;page=$page-&gt;show();  //把分页内容分配给前台模板</p>
<p>模板里分页数据调用:{$page}</p>
<p>**SESSION  保存到数据库<br />
1, 配置文件添加: 'SESSION_TYPE'=&gt;'Db',</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 04:26:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e6%96%87%e4%bb%b6/" title="文件">文件</a>, <a href="https://www.iamivan.net/tag/%e7%9b%ae%e5%bd%95/" title="目录">目录</a>, <a href="https://www.iamivan.net/tag/%e6%a8%a1%e6%9d%bf/" title="模板">模板</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>, <a href="https://www.iamivan.net/tag/thinkphp%e5%bc%80%e5%90%afpathinfo/" title="thinkphp开启pathinfo">thinkphp开启pathinfo</a>, <a href="https://www.iamivan.net/tag/array/" title="array">array</a>, <a href="https://www.iamivan.net/tag/thinkphp%e9%99%90%e5%88%b6%e8%b7%af%e5%be%84%e8%ae%bf%e9%97%ae/" title="thinkphp限制路径访问">thinkphp限制路径访问</a>, <a href="https://www.iamivan.net/tag/thinkphp%e4%b8%addistinct/" title="thinkphp中distinct">thinkphp中distinct</a>, <a href="https://www.iamivan.net/tag/%e8%8e%b7%e5%8f%96%e9%a1%b9%e7%9b%ae%e6%a0%b9%e7%9b%ae%e5%bd%95/" title="获取项目根目录">获取项目根目录</a>, <a href="https://www.iamivan.net/tag/__index%e6%96%b9%e6%b3%95/" title="&lowbar;&lowbar;index方法">&lowbar;&lowbar;index方法</a>, <a href="https://www.iamivan.net/tag/thinkphp%e6%95%b0%e6%8d%ae%e6%b7%bb%e5%8a%a0/" title="thinkphp数据添加">thinkphp数据添加</a>, <a href="https://www.iamivan.net/tag/thinkphp%e9%81%8d%e5%8e%86%e6%95%b0%e7%bb%84/" title="thinkPHP遍历数组">thinkPHP遍历数组</a>, <a href="https://www.iamivan.net/tag/thinkphp%e9%9a%90%e8%97%8findex-php/" title="thinkphp隐藏index&period;php">thinkphp隐藏index&period;php</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>ThinkPHP框架入门知识的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJOOnvb.html" rel="bookmark">PHP框架 ThinkPHP框架入门知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThinkPHP 是一个免费开源的,快速.简单的面向对象的 轻量级PHP开发框架 ,创立于2006年初,遵循Apache2开源协议发布,是为了敏捷WEB应用开发和简化企业应用开发而诞生的.ThinkPHP从诞生以来一直秉承简洁 实用的设计原则,在保持出色的性能和至简的代码的同时,也注重易用性.并且拥有众多的原创功能和特性,在社区团队的积极参与下,在易用性.扩展性和性能方 面不断优化和改进,已经成长为国内最领先和最具影响力的WEB应用开发框架,众多的典型案例确保可以稳定用于商业以及门户级的开发.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEWw9np.html" rel="bookmark">Java Mybatis框架入门基础教程&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.Mybatis介绍 MyBatis是一款一流的支持自定义SQL.存储过程和高级映射的持久化框架.MyBatis几乎消除了所有的JDBC代码,也基本不需要手工去 设置参数和获取检索结果.MyBatis能够使用简单的XML格式或者注解进行来配置,能够映射基本数据元素.Map接口和POJOs(普通java对象)到数据库中的记录. 二.MyBatis工作流程 (1)加载配置并初始化 触发条件:加载配置文件 配置来源于两个地方,一处是配置文件,一处是Java代码的注解,将SQL的配置信息加载成为一个个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqXrjz.html" rel="bookmark">CI框架入门之MVC简单示例&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了CI框架入门之MVC简单示例.分享给大家供大家参考,具体如下: 最简单的CI模型: 注意:模型需要用到数据库 配置文件在appcation/config.php 这里我们要用到数据库,需要将databases.php中的相关参数填写一下,具体不再赘述. 直接进入主题: MVC: 1.首先谈&quot;M&quot; 模型 CI中的模型存放在application/models文件夹里 命名规则是:类名_model.php 文件中只包含一个类: 如: class Nb_model extend			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrXkYxz.html" rel="bookmark">thinkPHP框架对接支付宝即时到账接口回调操作示例&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了thinkPHP框架对接支付宝即时到账接口回调操作.分享给大家供大家参考,具体如下: 关于支付宝即时收款接口的对接过程,很简单,也有很多人发过,我这里就不在啰嗦了,对接完成后,在线支付成功后的回调,相对来说,是个难点,,我重点分享下我的经验. 我在开发二代旅游CMS(http://www.erdaicms.com)的时候,在回调的时候,也花了不少时间. 不管是支付宝接口好是微信支付接口,回调都分为跳转回调和异步通知回调,跳转回调是不保险的,加入客人支付完成后马上把支付页面关闭,没跳			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4413Pz.html" rel="bookmark">ThinkPHP框架任意代码执行漏洞的利用及其修复方法&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ThinkPHP是国内著名的开源的PHP框架,是为了简化企业级应用开发和敏捷WEB应用开发而诞生的.最早诞生于2006年初,原名FCS,2007年元旦正式更名为ThinkPHP,并且遵循Apache2开源协议发布.早期的思想架构来源于Struts,后来经过不断改进和完善,同时也借鉴了国外很多优秀的框架和模式,使用面向对象的开发结 构和MVC模式,融合了Struts的Action和Dao思想和JSP的TagLib(标签库).RoR的ORM映射和ActiveRecord模式, 封装了CURD和一些常			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQ1KDGb.html" rel="bookmark">ThinkPHP快速入门实例教程之数据分页&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据分页可能是web编程里最常用到的功能之一.ThinkPHP实现分页功能十分简洁.只需要定义几个参数就可以实现.并且扩展也十分方便. 下面让我们从零开始实现ThinkPHP的分页程序吧. 1.首先,我们得创建一个用于分页测试的数据库 test.sql代码如下. CREATE TABLE `test` ( `id` int(10) unsigned NOT NULL auto_increment, `name` char(100) NOT NULL, `content` varchar(300)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNEEnob.html" rel="bookmark">ThinkPHP框架中添加404错误页面以及访问安全</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				所有的网站项目都需要添加一个404页面,不仅友好,而且对网站优化也有一定的好处,而用ThinkPHP框架搭建的网站添加404页面的方法还是很简单的,利用的就是空类,空方法 第一步: 在Lib/Action文件夹下创建EmptyAction.class.PHP &lt;?php class EmptyAction extends Action { function _empty(){ header(&quot;HTTP/1.0 404 Not Found&quot;); $this-&gt;display(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2yWA3z.html" rel="bookmark">OpenMP框架入门</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OpenMP 框架是使用 C.C++ 和 Fortran 进行并发编程的一种强大方法.GNU Compiler Collection (GCC) V4.2 支持 OpenMP 2.5 标准,而 GCC 4.4 支持最新的 OpenMP 3 标准.包括 Microsoft? Visual Studio 在内的其他编译器也支持 OpenMP.在本文中,您可以学习使用 OpenMP 编译指示 (pragma),寻找对 OpenMP 提供的一些应用程序编程接口 (API) 的 支持,并使用一些并行算法对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8Qoeb.html" rel="bookmark">PHP的Yii框架入门使用教程&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安装 Yii 的安装由如下两步组成: 从 yiiframework.com 下载 Yii 框架. 将 Yii 压缩包解压至一个 Web 可访问的目录. Tip|提示: 安装在 Web 目录不是必须的,每个 Yii 应用都有一个入口脚本,只有它才必须暴露给 Web 用户.其它 PHP 脚本(包括 Yii)应该保护起来不被 Web 访问,因为它们可能会被黑客利用.需求 安装完 Yii 以后你也许想验证一下你的服务器是否满足使用 Yii 的要求,只需浏览器中输入如下网址来访问需求检测脚本: http:			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMr0q1z.html" rel="bookmark" class="title">PHP采集类Snoopy&period;class&period;php介绍以及下载</a>
					<div>
						Snoopy 是一个非常强大的PHP类,可以利用该类模拟浏览器来完成获取网页内容和发送表单的任务.下面是详细介绍Snoopy.class.php 的特点和一些常见的用法. 官方网站:http://sn ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Nz71LqM.html" rel="bookmark" class="title">webwork2在weblogic下的中文问题解决</a>
					<div>
						web|解决|问题|中文 研究了几天webwork2我的习惯首先关注中文问题解决 我喜欢weblogic因为连地址栏写中文都没问题 中文这方面webwork2比struts更好解决  不用设置fitl ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp85qZz.html" rel="bookmark" class="title">ASP动态网页制作中使用SQL语句的方法</a>
					<div>
						sql|动态|网页|语句 1,SELECT 语句 在SQL的世界里,最最基础的操作就是SELECT 语句了.在数据库工具下直接采用SQL的时候很多人都会熟悉下面的操作: SELECT what FRO ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnGoOz.html" rel="bookmark" class="title">网站优化如何针对算法改变提前对网站进行布局</a>
					<div>
						最近几个月百度算法一直在升级中,面对升级很多网站要么被降权,要么被K,前不久百度又出了一个公告,主要是针对五种类型的站点,但是我们从公告中就可以看出网站是可以提前预防的,预防被百度算法调整中被K和被降 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrL4Vz.html" rel="bookmark" class="title">F&num;教程：List内包式</a>
					<div>
						F#的List和数组中,有一种被称为内包式的特殊标记方法.使用了这些,list相关的代码就会变得很简洁.我们就试着写如下代码: let evenarray = [| for x in 0..10 -& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myrg3kp.html" rel="bookmark" class="title">Java通过JDBC连接SQLServer 2008出现的问题</a>
					<div>
						环境:SQLServer 2008 R2 + MyEclipse 6.5 + JDK 1.6.24 问题:Java通过JDBC连接SQLServer 2008,出现如下问题:java.sql.SQLE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaKEJM.html" rel="bookmark" class="title">Win7系统文件无法删除怎么解决</a>
					<div>
						在使用win7系统时,你是否遇到过无法删除文件或文件夹的情况,通常碰到&quot;操作无法完成,文件正在另一个程序中运行&quot;无法删除,退出了该程序,也还是删不了.这该怎么办呢?本教程就为大家提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnxGe2b.html" rel="bookmark" class="title">PS打造个性水晶钮扣按钮与徽章制作教程</a>
					<div>
						介绍用PS设计打造个性水晶钮扣按钮或徽章效果,不会很复杂,主要用到图层样式,喜欢的同学可以跟着练习一下! photoshop教程效果图: 第一步 新建一个文件,填充黑色的背景,再画一个圆,我用绿色填充 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7vnlb.html" rel="bookmark" class="title">全面解析磁盘分区格式</a>
					<div>
						当前越来越多的用户已经从Windows 98逐步升级到更高级的系统了,随之而来的就是必须面对Windows 98/2000/XP/2003等系统的FAT16/FAT32/NTFS磁盘分区 格式,它们到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWEdZp.html" rel="bookmark" class="title">win8系统下如何设置快键关机方法</a>
					<div>
						  那么下面将教大家怎么设置win8系统快捷关机的方法,设置的相关详细步骤如下. 首先需要在右侧的的开始菜单中找到设置按钮,通过设置按钮进入到关机界面. 关机界面同样显示在右侧,点击&quot;电源& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGylap.html" rel="bookmark" class="title">搜索引擎套利的两种模式分析</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 套利,是金融学术语,学术化解释是在两个市场中,以有利的价格分别进行同种产品的买进和卖出.简单点来说,套利就是在交易行为进行之前,利润空间是已经确定的,并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZaQ2z.html" rel="bookmark" class="title">ThinkPHP文件上传实例教程&lowbar;php实例</a>
					<div>
						文件上传是很多PHP程序项目中常见的一个功能,今天本文就来分享一个完整的实例,来实现ThinkPHP文件上传的功能.具体方法如下: 一.action部分: FileAction.class.php页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze6La8b.html" rel="bookmark" class="title">VC 建立php扩展</a>
					<div>
						软件 php的源文件和安装包要一致 php5.3.8(VC9 x86 Thread Safe) php5.3.8源文件(tar.bz2)  VC bison.exe MSYS(MSYS类似于Cygwi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKQJGLp.html" rel="bookmark" class="title">【天池直播】同济教授分享应用算法优化航空运营（第一场运筹学领域直播）</a>
					<div>
						本周邀请同济大学教授.航空AI大赛冠军团队导师带来应用算法优化航空运营的分享. 梁老师将从时间维度上简要介绍航空公司运营过程中的规划步骤和关键流程,并以 &quot;机组排班问题&quot;和&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvr1D5M.html" rel="bookmark" class="title">javascript-js判断一个数组不包含一个数</a>
					<div>
						问题描述 js判断一个数组不包含一个数 比如一个数组[1234] 变量a从1循环到5,怎么把5这个数取出来 解决方案 Array.prototype.mycontains = function(e)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRxwdb.html" rel="bookmark" class="title">中信21世纪宣布正式更名&OpenCurlyDoubleQuote;阿里健康&rdquo;&comma;上月已生效</a>
					<div>
						中信21世纪宣布正式更名&quot; 阿里健康&quot;,上月已生效10月21日消息,中信21世纪有限公司今日发布公告,正式改名为&quot;阿里健康&quot;,英文名称由CITIC21CNCom ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK6ONb.html" rel="bookmark" class="title">c&num; excel-C&num;插入数据复制数据添加到新的excel上</a>
					<div>
						问题描述 C#插入数据复制数据添加到新的excel上 用C#来获取Excel的有效的数据对应的行数和列数,并且把数据存到二维数组中,再复制到新的Excel怎么写啊?用的是COM 解决方案 http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1BGKz.html" rel="bookmark" class="title">c语言-C语言中关于矩阵算法的问题</a>
					<div>
						问题描述 C语言中关于矩阵算法的问题 从一个m×n的整数矩阵中,找到x×y的子矩阵,使子矩阵中所有元素的和最大,并输出和及子矩阵所有元素.算法实现的思路是怎么样的? 解决方案 http://blog. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeOGJM.html" rel="bookmark" class="title">asp&period;net实现1、自动联系会员2、数据库备份和还原等功能&comma;求高手解答！要求思路和详细做法！</a>
					<div>
						问题描述 一.功能--------联系会员:以邮件的形式来联系会员(如会员生日当天自动发送邮件给会员)二.数据库的备份数据库的还原要求用方法做......... 解决方案 解决方案二:重赏之下必有勇夫					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwnnZM.html" rel="bookmark" class="title">浅谈优秀seoer具备的推广技巧</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 做站长不容易,做好站长更不容易,站 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW70jmM.html" rel="bookmark" class="title">细品javascript 寻址&comma;闭包&comma;对象模型和相关问题&lowbar;javascript技巧</a>
					<div>
						正是因为JS是动态语言,所以JS的寻址是现场寻址,而非像C一样,编译后确定.此外,JS引入了this指针,这是一个很麻烦的东西,因为它&quot;隐式&quot;作为一个参数传到函数里面.我们先看&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyKgo5z.html" rel="bookmark" class="title">后台方法可以执行，json数据也有了，但是data为空，不知道什么原因</a>
					<div>
						问题描述 后台方法可以执行,json数据也有了,但是data为空,不知道什么原因 alert(name); var url=&quot;&lt;%=basePath %&gt;CylServlet?m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWdD9Gp.html" rel="bookmark" class="title">广东电信启动天翼3G校园行动</a>
					<div>
						临近开学,中国电信广东公司将在校园内启动&quot;天翼3G&quot;动力联盟校园行活动,WLAN无线上网和校园套餐将给校园3G生活带来全新的体验.据了解,中国电信在大学校园内将构建由WLAN与3G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmRjOlz.html" rel="bookmark" class="title">连载：面向对象葵花宝典：思想、技巧与实践（7） - &OpenCurlyDoubleQuote;对象&rdquo;新解</a>
					<div>
						有了&quot;类&quot;的清晰定义后,&quot;对象&quot;就比较容易理解了. 对象就是一个具体的类,一个真实存在的类. 前面我们提到面向对象是对现实世界的模拟,那么对象就是现实世界中存在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAXkLp.html" rel="bookmark" class="title">居中 html css</a>
					<div>
						&lt;div id=&quot;main&quot; style=&quot;width:800px;height: 600px;margin:0 auto&quot;&gt; &lt;!-- 这里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdvJAAb.html" rel="bookmark" class="title">F5 为多云环境提供一致的应用服务</a>
					<div>
						F5 Networks(NASDAQ:FFIV) 宣布推出能够为多云环境提供一致应用服务的全新解决方案,旨在帮助企业提升部署灵活性.提高安全性并加快上市速度. F5 发布的2017 年应用交付状态报告 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPWy5rM.html" rel="bookmark" class="title">IOS应用开发－数据库创建</a>
					<div>
						一.前言 数据库作为一种数据载体被我们频繁地使用.一般情况下我们会在程序的入口方法处完成数据库的创建.下面通过实例简单介绍两种创建数据库的方法. 二.需求 在documents目录下创建一个test. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkZe4EM.html" rel="bookmark" class="title">三大经典水浒引领时代潮流</a>
					<div>
						回合制游戏以其休闲娱乐的特色一直都在游戏界的发展史上占据半壁江山,从最初仙剑.梦幻西游到如今的桃园.水浒Q传!回合制每隔几年,便会有一次大的震荡!本人自&lt;石器时代&gt;起就对回合制游戏情有独钟 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXNkgKb.html" rel="bookmark" class="title">《数据结构与算法 C语言版》&mdash;&mdash; 1&period;1数据结构的研究对象</a>
					<div>
						1.1数据结构的研究对象 自然界中的许多问题是可以用数学工具进行描述的.例如,造桥中的受力问题可描述为线性方程,人口增长的情况可描述为微分方程.但更多的非数值计算问题无法用数学方程加以描述.因此,解决 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmdJOBM.html" rel="bookmark" class="title">支付宝倡议第三方支付企业拒绝不法网站</a>
					<div>
						9月16日下午消息,第三方支付企业支付宝今日宣布已经与公安机关以及各大银行建立起信息互通的机制,对于从事网络色情.赌博的不法分子,支付宝将提供相关信息予以严厉打击,同时倡议所有企业一起行动起来,停止为 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.040 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
